'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.modifyData = undefined;

var modifyData = exports.modifyData = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(query, update) {
    var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    var description, mongoUrl, definition, db, _splitQuery, look, lookup, result;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            description = config.description, mongoUrl = config.mongoUrl;
            definition = (0, _transactionsDescriptionDefinition.createDefinition)(description);
            _context.next = 4;
            return _mongodb.MongoClient.connect(mongoUrl);

          case 4:
            db = _context.sent;
            _splitQuery = (0, _transactionsToolsIsomorphic.splitQuery)(query), look = _splitQuery.look, lookup = _splitQuery.lookup;
            _context.next = 8;
            return (0, _transactionsExpressRestMongodb.modify)(look, update, Object.assign({ db: db,
              definition: definition,
              lookup: lookup
            }, config));

          case 8:
            result = _context.sent;

            db.close();
            return _context.abrupt('return', result);

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function modifyData(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _mongodb = require('mongodb');

var _transactionsExpressRestMongodb = require('transactions-express-rest-mongodb');

var _transactionsDescriptionDefinition = require('transactions-description-definition');

var _transactionsToolsIsomorphic = require('transactions-tools-isomorphic');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }