'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.requestData = undefined;

var requestData = exports.requestData = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(method, options) {
    var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var authToken, url, Authorization, token, dataPath, requestUrl, json;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // unpack
            authToken = config.authToken, url = config.url;
            Authorization = 'JWT ' + authToken;

            if (authToken) {
              _context.next = 7;
              break;
            }

            _context.next = 5;
            return (0, _token.tokenData)(null, null, config);

          case 5:
            token = _context.sent;

            Authorization = 'JWT ' + token.authToken;

          case 7:
            dataPath = config.dataPath || '/data';
            requestUrl = url + dataPath;
            // fetch

            _context.next = 11;
            return (0, _transactionsReduxRequest.getRequestedJSON)(method, { options: options }, {
              headers: { Authorization: Authorization },
              url: requestUrl
            });

          case 11:
            json = _context.sent;
            return _context.abrupt('return', json);

          case 13:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function requestData(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

require('fetch-everywhere');

var _transactionsReduxRequest = require('transactions-redux-request');

var _token = require('./token');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }