'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tokenData = undefined;

var tokenData = exports.tokenData = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(email, password) {
    var config = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var url, credential, tokenPath, tokenUrl, result;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // unpack
            url = config.url;
            credential = { email: email, password: password };

            if (!(!email || !password)) {
              _context.next = 9;
              break;
            }

            if (config.mongoUrl) {
              _context.next = 6;
              break;
            }

            console.warn('you need to add a mongoUrl in your config');
            return _context.abrupt('return');

          case 6:
            _context.next = 8;
            return (0, _sign.signData)(config.mongoUrl, config);

          case 8:
            credential = _context.sent;

          case 9:
            tokenPath = config.tokenPath || '/sign/token';
            tokenUrl = url + tokenPath;
            // fetch

            _context.next = 13;
            return fetch(tokenUrl, {
              body: JSON.stringify(credential),
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json'
              }
            });

          case 13:
            result = _context.sent;
            _context.next = 16;
            return result.json();

          case 16:
            return _context.abrupt('return', _context.sent);

          case 17:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function tokenData(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

require('fetch-everywhere');

var _sign = require('./sign');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }