'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _eval = require('../setters/eval');

var _eval2 = _interopRequireDefault(_eval);

var _map = require('../setters/map');

var _map2 = _interopRequireDefault(_map);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var setters = [_map2.default, _eval2.default];

var setCustomizer = function setCustomizer(customizersByCollectionName) {
  customizersByCollectionName['defaults'] = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(document) {
      var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var db, keys, documents, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _loop, _iterator, _step;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // unpack
              db = config.db;
              // parse

              keys = Object.keys(document);
              documents = [document];
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context.prev = 6;

              _loop = function _loop() {
                var key = _step.value;

                var value = document[key];
                setters.forEach(function (setter) {
                  documents = setter(documents, key, value);
                });
              };

              for (_iterator = keys[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                _loop();
              }
              // return
              _context.next = 15;
              break;

            case 11:
              _context.prev = 11;
              _context.t0 = _context['catch'](6);
              _didIteratorError = true;
              _iteratorError = _context.t0;

            case 15:
              _context.prev = 15;
              _context.prev = 16;

              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }

            case 18:
              _context.prev = 18;

              if (!_didIteratorError) {
                _context.next = 21;
                break;
              }

              throw _iteratorError;

            case 21:
              return _context.finish(18);

            case 22:
              return _context.finish(15);

            case 23:
              return _context.abrupt('return', documents);

            case 24:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[6, 11, 15, 23], [16,, 18, 22]]);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();
};

exports.default = setCustomizer;