'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tinify = undefined;

var _setters = require('./setters');

Object.keys(_setters).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _setters[key];
    }
  });
});

var _tasks = require('./tasks');

Object.keys(_tasks).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _tasks[key];
    }
  });
});

var _uses = require('./uses');

Object.keys(_uses).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _uses[key];
    }
  });
});

var _utils = require('./utils');

Object.keys(_utils).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _utils[key];
    }
  });
});

var _scrapDansTesMains = require('scrap-dans-tes-mains');

exports.tinify = _scrapDansTesMains.tinify;