'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _context = require('../utils/context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getEvalDocuments(documents, key, value) {
  // type
  if (typeof value !== 'string') {
    return documents;
  }
  // match
  var evalMatch = value.match(/_eval_(.*)/);
  if (!evalMatch || !evalMatch[1]) {
    return documents;
  }
  // parse
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = documents[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var document = _step.value;

      // important to not use an arrow function here
      // because we want the special context of the function
      document[key] = function (str) {
        return eval(str);
      }.call(_context2.default, evalMatch[1]);
    }
    // return
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return documents;
}

exports.default = getEvalDocuments;