'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash.flatten');

var _lodash2 = _interopRequireDefault(_lodash);

var _context = require('../utils/context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function getMapDocuments(documents, key, value) {
  // type
  if (typeof value !== 'string') {
    return documents;
  }
  // match
  var mapMatch = value.match(/_map_(.*)/);
  if (!mapMatch || !mapMatch[1]) {
    return documents;
  }
  // parse
  var mapDocuments = (0, _lodash2.default)(documents.map(function (document) {
    var elements = function (str) {
      return eval(str);
    }.call(_context2.default, mapMatch[1]);
    return elements.map(function (element) {
      return Object.assign({}, document, _defineProperty({}, key, element));
    });
  }));
  // return
  return mapDocuments;
}

exports.default = getMapDocuments;