'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterData = undefined;

var filterData = exports.filterData = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(query, config) {
    var description, mongoUrl, definition, db, _splitQuery, after, look, lookup, result;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            description = config.description, mongoUrl = config.mongoUrl;
            definition = (0, _transactionsDescriptionDefinition.createDefinition)(description);
            _context.t0 = config.db;

            if (_context.t0) {
              _context.next = 7;
              break;
            }

            _context.next = 6;
            return _mongodb.MongoClient.connect(mongoUrl);

          case 6:
            _context.t0 = _context.sent;

          case 7:
            db = _context.t0;
            _splitQuery = (0, _transactionsToolsIsomorphic.splitQuery)(query), after = _splitQuery.after, look = _splitQuery.look, lookup = _splitQuery.lookup;
            _context.next = 11;
            return (0, _transactionsExpressRestMongodb.filter)(look, Object.assign({ after: after,
              db: db,
              definition: definition,
              lookup: lookup
            }, config));

          case 11:
            result = _context.sent;

            db.close();
            return _context.abrupt('return', result);

          case 14:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function filterData(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _mongodb = require('mongodb');

var _transactionsExpressRestMongodb = require('transactions-express-rest-mongodb');

var _transactionsDescriptionDefinition = require('transactions-description-definition');

var _transactionsToolsIsomorphic = require('transactions-tools-isomorphic');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }