'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.grabData = undefined;

var grabData = exports.grabData = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var mongoUrl, type, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, option, isCache, isWritten, jsonDataDir, name;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            mongoUrl = config.mongoUrl, type = config.type;
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 4;
            _iterator = options[Symbol.iterator]();

          case 6:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 14;
              break;
            }

            option = _step.value;
            isCache = option.isCache, isWritten = option.isWritten, jsonDataDir = option.jsonDataDir, name = option.name;
            _context.next = 11;
            return (0, _grabDansTesMains.grab)(name, { cache: String(isCache),
              dir: jsonDataDir,
              mongo: mongoUrl,
              save: 'true',
              type: type,
              write: String(isWritten)
            });

          case 11:
            _iteratorNormalCompletion = true;
            _context.next = 6;
            break;

          case 14:
            _context.next = 20;
            break;

          case 16:
            _context.prev = 16;
            _context.t0 = _context['catch'](4);
            _didIteratorError = true;
            _iteratorError = _context.t0;

          case 20:
            _context.prev = 20;
            _context.prev = 21;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 23:
            _context.prev = 23;

            if (!_didIteratorError) {
              _context.next = 26;
              break;
            }

            throw _iteratorError;

          case 26:
            return _context.finish(23);

          case 27:
            return _context.finish(20);

          case 28:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[4, 16, 20, 28], [21,, 23, 27]]);
  }));

  return function grabData(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _grabDansTesMains = require('grab-dans-tes-mains');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }