'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.webshotData = undefined;

var webshotData = exports.webshotData = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(urlOrUrls) {
    var _this = this;

    var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var bucketName, urls, s3, result;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            // unpack
            bucketName = config.bucketName;
            urls = Array.isArray(urlOrUrls) ? urlOrUrls : [urlOrUrls];
            // s3

            s3 = config.s3 || (0, _s.getS3)(config);
            // init

            result = {};
            // webshot, make sure the scrap worked first

            _context2.next = 6;
            return Promise.all(urls.map(function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(url, index) {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return (0, _scrapDansTesMains.webshotToS3)(url, { bucketName: bucketName, s3: s3 });

                      case 2:
                        return _context.abrupt('return', _context.sent);

                      case 3:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x3, _x4) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 6:
            result.webshotUrls = _context2.sent;

            // impedance
            if (result.webshotUrls.length === 1) {
              result.webshotUrl = result.webshotUrls && result.webshotUrls[0];
              delete result.webshotUrls;
            }
            // return
            return _context2.abrupt('return', result);

          case 9:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function webshotData(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _scrapDansTesMains = require('scrap-dans-tes-mains');

var _s = require('../utils/s3');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }